## tthsum 1.1.0

=== Makefile ===
# tthsum makefile
# 
# Makefile for GNU Make.

.PHONY: all clean dists install manual tthsum uninstall

ifeq ($(ARCH),)
  ARCH = $(shell uname -m)
endif
ifndef $(BIN)
  BIN = $(DESTDIR)/usr/local/bin
endif
ifndef $(MAN)
  MAN = $(DESTDIR)/usr/local/man
endif


CC = gcc
CFLAGS = -fomit-frame-pointer -Wall -O3 -march=$(ARCH)
LDFLAGS = -Wall -O3 -march=$(ARCH)
GZIP = gzip -9 -c
RM = rm -rf

CPPFLAGS = -DUSE_SETERROR2 -DNDEBUG

BINS = obj-$(ARCH)
SHARES = share
SRC = \
	base32.c \
	escape.c \
	getopt.c \
	main.c \
	read.c \
	texts.c \
	thex.c \
	tiger.c \
	tthsum.c \
	utf8.c
OBJS = $(patsubst %.c,$(BINS)/%.o, $(SRC))


all: tthsum manual

install: tthsum manual
	install -d $(BIN) $(MAN)/man1
	install $(BINS)/tthsum $(BIN)
	install -m644 $(SHARES)/tthsum.1.gz $(MAN)/man1

uninstall:
	$(RM) $(BIN)/tthsum
	$(RM) $(MAN)/man1/tthsum.1.gz

tthsum: $(BINS)/tthsum

manual: $(SHARES)/tthsum.1.gz

$(SHARES)/tthsum.1.gz: tthsum.1
	@mkdir -p $(SHARES)
	$(GZIP) $< > $@

dists: clean
	sh -c 'X=`basename \`pwd\`` ; \
		tar zvcf ../$$X.tar.gz -C.. $$X'
	sh -c 'X=`basename \`pwd\`` ; \
		tar jvcf ../$$X.tar.bz2 -C.. $$X'
	#sh -c 'X=`basename \`pwd\`` ; cp ../$$X.tar.gz /usr/src/rpm/SOURCES/'
	#rpm -bs rpm/tthsum.spec
	#rpm -bb rpm/tthsum.spec

clean:
	$(RM) $(BINS) $(SHARES)

$(BINS)/%.o: %.c
	@mkdir -p $(BINS)
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $< -o $@

$(BINS)/tthsum: $(OBJS)

## tthsum 1.3.1

=== Makefile ===
# tthsum makefile
# 
# Makefile for GNU Make.

.PHONY: all clean dists install manual tthsum uninstall test runtest

ifeq ($(BIN),)
  BIN = $(DESTDIR)/usr/local/bin
endif
ifeq ($(MAN),)
  MAN = $(DESTDIR)/usr/local/man
endif

ifeq ($(DEBUG),)
  override CPPFLAGS += -DNDEBUG
  CFLAGS += -O3 #-fno-stack-protector #-march=native
  LDFLAGS += -O3 #-march=native
else
  override CPPFLAGS += -DDEBUG
  CFLAGS += -g #-pg
  LDFLAGS += -g #-pg
endif

CC ?= gcc
GZIP = gzip -9 -c
RM = rm -rf

override CPPFLAGS += -D_FILE_OFFSET_BITS=64 -DUSE_TEXTS #-DUSE_MY_GETOPT
CFLAGS += -Wall #-pedantic #-ansi
LDFLAGS += -Wall

BINS = obj-unix
SHARES = share
APPSRC = base32.c escape.c getopt.c read.c texts.c thex.c tiger.c \
	tthsum.c utf8.c
APPOBJ = $(patsubst %.c,$(BINS)/%.o, $(APPSRC))
APPENTRY = $(BINS)/main.o
TSTSRC = $(APPSRC) base32_test.c endian_test.c escape_test.c getopt_test.c \
	read_test.c texts_test.c thex_test.c tiger_test.c types_test.c \
	utf8_test.c
TSTOBJ = $(patsubst %.c,$(BINS)/%.o, $(TSTSRC))
TSTENTRY = $(BINS)/test.o

# "autoconf"
override CPPFLAGS += $(shell cat $(BINS)/autoconf.cppflags)


all: tthsum manual test runtest

install: tthsum manual test runtest
	install -d $(BIN) $(MAN)/man1
	install $(BINS)/tthsum $(BIN)
	install -m644 $(SHARES)/tthsum.1.gz $(MAN)/man1

uninstall:
	$(RM) $(BIN)/tthsum
	$(RM) $(MAN)/man1/tthsum.1.gz

tthsum: $(BINS)/tthsum

manual: $(SHARES)/tthsum.1.gz

test: $(BINS)/test

runtest: test tthsum
	$(BINS)/test
	$(BINS)/tthsum $(BINS)/tthsum $(BINS)/test | $(BINS)/tthsum -cv

dists:
	sh -c 'X=`basename \`pwd\`` ; for opts in "zcf ../$$X.tar.gz" \
	  "jcf ../$$X.tar.bz2" ; do tar $$opts --no-recursion -C.. \
	  `svn ls ../$$X | sed -e "s#^#$$X/#"` ; done'
	#sh -c 'X=`basename \`pwd\`` ; cp ../$$X.tar.gz /usr/src/rpm/SOURCES/'
	#rpm -bs rpm/tthsum.spec
	#rpm -bb rpm/tthsum.spec

clean:
	$(RM) $(BINS) $(SHARES)

$(BINS)/%.o: %.c
	@mkdir -p $(BINS)
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $< -o $@

$(BINS)/tthsum: $(APPOBJ) $(APPENTRY)

$(SHARES)/tthsum.1.gz: tthsum.1
	@mkdir -p $(SHARES)
	$(GZIP) $< > $@

$(BINS)/test: $(TSTOBJ) $(TSTENTRY)

# "autoconf"
$(BINS)/autoconf.cppflags: autoconf.c
	@mkdir -p $(BINS)
	$(CC) $(CFLAGS) -c autoconf.c -o $(BINS)/autoconf.o
	$(CC) $(LDFLAGS) $(BINS)/autoconf.o -o $(BINS)/autoconf
	$(BINS)/autoconf >$(BINS)/autoconf.cppflags
$(APPOBJ): $(BINS)/autoconf.cppflags
$(TSTOBJ): $(BINS)/autoconf.cppflags

=== debian/changelog ===
tthsum (1.3.1-2) unstable; urgency=low

  * Fix big endian test fails on kfreebsd-amd64 (Closes: #664144)
    - Thanks Petr Salinger for patch.
  * Switch to use packaging format 3.0 quilt.

 -- Hector Oron <zumbi@debian.org>  Sat, 05 Jan 2013 09:52:34 +0000

tthsum (1.3.1-1) unstable; urgency=low

  * New upstream release (Closes: #644895, #517619, #599173)
    - Fix buffer overrun in tiger tests. Reported by Edward Sheldrake.
    - Force alignment on platforms that need it using a compile-time test. Thanks
      go out to pavelch for providing failing test cases and to Zoiah for lending
      me an ARM ;-)
      (I added a minimal autoconf.c as a faster alternative to proper autconf.)
    - Fix a rather serious problem with the big endian code. Non-trivial files over
      1024 bytes would not have had proper hashes calculated. (Debian bug #517619)
    - New test cases and tweaks to existing tests.
    - Fix so compilation with -ansi works.
    - Fix another problem with alignment on an ARM with -O3 optimization. Thanks
      Hector Oron for hooking me up with access to the debian ARM box.
    - Fix problems with debian packaging. (Debian bug #599173 and CPPFLAGS
      override.)
    - Minor code and build system cleanup.
    - Changed -p output to print percentages instead of MiB counts.
    - Base32 decoding errors did not generate a valid error message. (Error code
      0 conflicted with SUCCESS.)
    - Fixed that ctrlesctostr accepted strange BASE36 escape sequences.
    - Made getopt for Windows more compatible with POSIX getopt.
    - Fixed that including the tthsum specific texts.c is optional.
    - Changed some header inclusions to be more compliant with C specs and made
      the source a bit more strict (ANSI C compatible, C++ compatible).
    - Added a test suite to detect stupid bugs at compile time. (Like the next
      bug.)
    - Endianness was not properly detected on various architectures (see debian
      bug 517619; thanks Alan Curry <pacman> for reporting).
    - Standardized UTF8 functions to behave as specified on Windows.
    - Corrected the need for a double EOF when reading from stdin.
    - Changed license from GPLv2 to GPLv3. Updated help texts (suggesting gmake
      on non-Linuxen, for instance).
    - Removed a bit of overhead on big endian platforms.
  * New maintainer.
  * Bump Standards-Version to 3.9.3
  * Bump debhelper compat version to 8
  * Add Homepage stanza
  * Add watch file

 -- Hector Oron <zumbi@debian.org>  Mon, 05 Mar 2012 01:24:01 +0000

tthsum (1.1.0-1) unstable; urgency=low

  * initial upload (closes: #312503)

 -- RISKO Gergely <risko@debian.org>  Mon,  4 Jul 2005 02:10:00 +0200

=== debian/control ===
Source: tthsum
Section: utils
Priority: optional
Maintainer: Hector Oron <zumbi@debian.org>
Build-Depends: cdbs, debhelper (>=8)
Standards-Version: 3.9.3
Homepage: http://tthsum.devs.nu/

Package: tthsum
Architecture: any
Depends: ${shlibs:Depends}
Description: generates or checks TTH message digests
 tthsum generates or checks TTH checksums (root of the THEX hash
 tree).  The Merkle Hash Tree, invented by Ralph Merkle, is a hash
 construct that exhibits desirable properties for verifying the
 integrity of files and file subranges in an incremental or
 out-of-order fashion.  tthsum uses the Tiger hash algorithm for both
 the internal and the leaf nodes.
 .
 The specification of the THEX algorithm is at:
 http://www.open-content.net/specs/draft-jchapweske-thex-02.html
 .
 The specification of the Tiger hash algorithm is at:
 http://www.cs.technion.ac.il/~biham/Reports/Tiger/

## tthsum 1.3.2

=== Makefile ===
--- 
+++ 
@@ -31,6 +31,8 @@
 
 BINS = obj-unix
 SHARES = share
+HEADERS = base32.h endian.h escape.h getopt.h read.h test.h texts.h \
+	thex.h tiger.h tthsum.h types.h utf8.h
 APPSRC = base32.c escape.c getopt.c read.c texts.c thex.c tiger.c \
 	tthsum.c utf8.c
 APPOBJ = $(patsubst %.c,$(BINS)/%.o, $(APPSRC))
@@ -77,6 +79,10 @@
 clean:
 	$(RM) $(BINS) $(SHARES)
 
+# TSTSRC includes APPSRC
+$(TSTSRC) autoconf.c: $(HEADERS)
+	touch $(TSTSRC) autoconf.c
+
 $(BINS)/%.o: %.c
 	@mkdir -p $(BINS)
 	$(CC) $(CPPFLAGS) $(CFLAGS) -c $< -o $@
@@ -92,7 +98,7 @@
 # "autoconf"
 $(BINS)/autoconf.cppflags: autoconf.c
 	@mkdir -p $(BINS)
-	$(CC) $(CFLAGS) -c autoconf.c -o $(BINS)/autoconf.o
+	$(CC) $(CPPFLAGS) $(CFLAGS) -c autoconf.c -o $(BINS)/autoconf.o
 	$(CC) $(LDFLAGS) $(BINS)/autoconf.o -o $(BINS)/autoconf
 	$(BINS)/autoconf >$(BINS)/autoconf.cppflags
 $(APPOBJ): $(BINS)/autoconf.cppflags

=== debian/changelog ===
tthsum (1.3.2-2) unstable; urgency=medium

  * QA upload.
    Closes: #1119642
  * Maintain package in Debian team
  * d/watch
     - Version=5
     - Fix
  * d/copyright: DEP5 + review
  * Convert from cdbs to dh
    Closes: #1114786
  * Standards-Version: 4.7.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * debputy lint --auto-fix (routine-update)
  * Depends: ${misc:Depends}
  * d/rules: hardening
  * Lintian-overrides for insecure URI in watch file

 -- Andreas Tille <tille@debian.org>  Sat, 15 Nov 2025 16:16:41 +0100

tthsum (1.3.2-1) unstable; urgency=medium

  * New upstream release:
    - Update manpage, fixing incorrect use of hyphens which should be minuses in
      most cases. And update URL to the thex specification.
    - Add __GLIBC__ to __linux check in endian.h so endianness is correctly
      detected on kFreeBSD. Reported by Christoph Egger. Patch by Petr Salinger.
      (Debian bug #664144.)
    - Probably fix "dpkg-buildflags-missing CPPFLAGS" debian warning.
    - Makefile ensures recompilation on header file changes.
    - Fix "N out of M files failed" tthsum -v message.
    - Fix that the text tests shouldn't fail when you're using localized errors.
      You get a warning instead.
    - Replace -1 in set_error() api with ERROR_FROM_OS.
    - Replaced sprintf usage in texts internals.

 -- Hector Oron <zumbi@debian.org>  Wed, 24 Sep 2014 01:34:15 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,19 @@
 Source: tthsum
+Standards-Version: 4.7.2
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Section: utils
 Priority: optional
-Maintainer: Hector Oron <zumbi@debian.org>
-Build-Depends: cdbs, debhelper (>=8)
-Standards-Version: 3.9.3
+Build-Depends:
+ debhelper-compat (= 13),
+Vcs-Browser: https://salsa.debian.org/debian/tthsum
+Vcs-Git: https://salsa.debian.org/debian/tthsum.git
 Homepage: http://tthsum.devs.nu/
 
 Package: tthsum
 Architecture: any
-Depends: ${shlibs:Depends}
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends}
 Description: generates or checks TTH message digests
  tthsum generates or checks TTH checksums (root of the THEX hash
  tree).  The Merkle Hash Tree, invented by Ralph Merkle, is a hash

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_install:
	BIN=$(CURDIR)/debian/`dh_listpackages`/usr/bin MAN=$(CURDIR)/debian/`dh_listpackages`/usr/share/man dh_auto_install

=== debian/watch ===
Version: 5

Source: http://tthsum.devs.nu/
Matching-Pattern: pkg/tthsum-(.+)\.tar\.gz
